<template>
  <div class="register">
    <div class="loginBox">
      <div class="login-top">
        <span style="font-size:22px">Edge Gallery Lab User Registration</span>
      </div>
      <el-form
        :model="userData"
        status-icon
        :rules="rules"
        ref="userData"
        class="demo-ruleForm"
      >
        <div class="login-area">
          <el-form-item prop="username">
            <el-input
              id="name"
              v-model="userData.username"
              auto-complete="new-accounts"
              type="text"
              :placeholder="$t('user.username')"
            />
          </el-form-item>
          <el-form-item prop="password">
            <el-input
              id="firstpwd"
              v-model="userData.password"
              auto-complete="new-password"
              type="password"
              :placeholder="$t('login.password')"
            />
          </el-form-item>
          <el-form-item prop="confirmPassword">
            <el-input
              id="secondpwd"
              v-model="userData.confirmPassword"
              type="password"
              :placeholder="$t('login.pwdConfPla')"
            />
          </el-form-item>
          <el-form-item prop="email">
            <el-input
              id="emailPass"
              v-model="userData.email"
              type="text"
              :placeholder="$t('user.email')"
            />
          </el-form-item>
          <el-form-item prop="company">
            <el-input
              id="company"
              v-model="userData.company"
              type="text"
              :placeholder="$t('login.compPla')"
            />
          </el-form-item>
          <el-form-item prop="gender">
            <p style="text-align:left">
              <el-radio
                v-model="userData.gender"
                label="male"
              >
                Male
              </el-radio>
              <el-radio
                v-model="userData.gender"
                label="female"
              >
                Female
              </el-radio>
            </p>
          </el-form-item>
        </div>
        <div>
          <el-button
            type="primary"
            size="medium"
            :loading="regBtnLoading"
            @click="submitForm('userData')"
          >
            Submit
          </el-button>
          <el-button
            type="primary"
            size="medium"
            @click="closeSucessPop()"
          >
            Cancel
          </el-button>
        </div>
      </el-form>
    </div>
  </div>
</template>
<script>
import axios from 'axios'
import { BASE_URL } from '../tools/constant.js'
export default {
  name: 'Register',
  components: {

  },
  data () {
    var validateName = (rule, value, callback) => {
      if (value === '') {
        callback(new Error('Username cannot be empty'))
      } else {
        if (this.userData.username !== '') {
          this.$refs.userData.validateField('name')
        }
        callback()
      }
    }
    var validatePass = (rule, value, callback) => {
      if (value === '') {
        callback(new Error('Password cannot be empty'))
      } else {
        if (this.userData.password !== '') {
          this.$refs.userData.validateField('firstpwd')
        }
        callback()
      }
    }
    var validatePassConfirm = (rule, value, callback) => {
      if (value === '') {
        callback(new Error('Confirm Password cannot be empty'))
      } else if (value !== this.userData.password) {
        callback(new Error('Two different passwords'))
      } else {
        callback()
      }
    }
    var validateCompany = (rule, value, callback) => {
      if (value === '') {
        callback(new Error('Company cannot be empty'))
      }
      callback()
    }
    var validateGender = (rule, value, callback) => {
      if (value === '') {
        callback(new Error('Select gender.'))
      }
      callback()
    }
    var validateEmail = (rule, value, callback) => {
      if (value === '' || value === undefined) {
        callback(new Error('Email cannot be empty'))
      } else {
        if (this.userData.email !== '') {
          this.$refs.userData.validateField('emailPass')
        }
        callback()
      }
    }
    return {
      visible: false,
      userData: {
        username: '',
        password: '',
        confirmPassword: '',
        telephone: '',
        company: '',
        gender: '',
        role: ''
      },
      rules: {
        username: [
          { validator: validateName, trigger: 'blur' },
          { pattern: /^[a-zA-Z0-9](_(?!(\.|_))|\.(?!(_|\.))|[a-zA-Z0-9]){4,18}[a-zA-Z0-9]$/, message: 'Only latters, numbers, minimum 6 characters' }
        ],
        password: [
          { validator: validatePass, trigger: 'blur' },
          { pattern: /^(?=.*\d)(?=.*[!@#$%^&*])(?=.*[a-z])(?=.*[A-Z]).{6,16}$/, message: '6-16 digit Numbers, letters, special characters' }
        ],
        confirmPassword: [
          { validator: validatePassConfirm, trigger: 'blur' }
        ],
        email: [
          { validator: validateEmail, trigger: 'blur' },
          { pattern: /^[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+@[a-zA-Z0-9-]+(?:\.[a-zA-Z0-9-]+)*$/, message: 'Email is not in accordance with the rules' }
        ],
        company: [
          { validator: validateCompany, trigger: 'blur' }
        ],
        gender: [
          { validator: validateGender, trigger: 'blur' }
        ]
      },
      regBtnLoading: false
    }
  },
  created () {
    this.keyupSubmit()
    if (this.$route.hash === '#1') {
      this.type = 1
    } else {
      this.type = 2
    }
  },
  methods: {
    jumpTo (path) {
      if (this.$route.path !== path) {
        this.$router.push(path)
      }
    },
    to () {
      if (this.type === 1) {
        this.jumpTo('/admin/users')
      } else {
        this.jumpTo('/')
      }
    },
    submitForm (formName) {
      this.$refs[formName].validate((valid) => {
        if (valid) {
          this.regBtnLoading = true
          let url = BASE_URL + '/register'
          axios({
            method: 'POST',
            url: url,
            data: this.userData,
            headers: {
              // 'Authorization': this.getToken(),
              'Content-Type': 'application/json'
            }
          }).then(res => {
            this.$parent.successMessage(this.$t('confirm.registerUserSuccess'))
            this.regBtnLoading = false
            this.jumpTo('/login')
          }, error => {
            if (error) {
              this.$parent.errorMessage(this.$t(error.response.data))
            }
            this.regBtnLoading = false
          })
        } else {
          console.log('error submit!!')
          return false
        }
      })
    },
    closePop () {
      this.userData = ''
    },
    closeSucessPop () {
      this.jumpTo('/login')
    },
    keyupSubmit () {
      document.onkeydown = e => {
        let _key = window.event.keyCode
        if (_key === 13) {
          this.submitForm()
        }
      }
    },
    resetForm () {

    },
    getToken () {
      let strCookie = document.cookie
      let arrCookie = strCookie.split(';')
      for (let i = 0; i < arrCookie.length; i++) {
        let arr = arrCookie[i].split('=Basic')
        if (arr[0].trim() === 'token') {
          return 'Basic ' + arr[1]
        }
      }
      return ''
    }
  }
}
</script>
<style>
    .register {
        background-image: url("../assets/images/login.png");
        width: 100vw;
        height: 100vh;
        background-size: 100% 100%;
        background-repeat: no-repeat;
        position: relative;
    }
    .loginBox {
        float: right;
        width: 20%;
        height: auto;
        text-align: center;
        margin: 10% 10% 0 0;
        padding:15px;
        background: #fff;
        box-shadow: 0 2px 4px 0 rgba(0,0,0,0.16),0 2px 10px 0 rgba(0,0,0,0.12)!important;
    }
    .login-area {
        padding: 0 25px;
        margin-top:25px;
    }
</style>
